diff --git a/drivers/net/wireless/intel/iwlwifi/cfg/22000.c b/drivers/net/wireless/intel/iwlwifi/cfg/22000.c
index 70005e6b2d57..172ca18d888b 100644
--- a/drivers/net/wireless/intel/iwlwifi/cfg/22000.c
+++ b/drivers/net/wireless/intel/iwlwifi/cfg/22000.c
@@ -215,12 +215,6 @@ const struct iwl_cfg iwl_qu_hr = {
 	.num_rbds = IWL_NUM_RBDS_22000_HE,
 };
 
-const struct iwl_cfg iwl_ax201_cfg_qu_hr = {
-	.name = "Intel(R) Wi-Fi 6 AX201 160MHz",
-	IWL_DEVICE_22500,
-	.num_rbds = IWL_NUM_RBDS_22000_HE,
-};
-
 const struct iwl_cfg iwl_ax200_cfg_cc = {
 	.fw_name_pre = IWL_CC_A_FW_PRE,
 	IWL_DEVICE_22500,
diff --git a/drivers/net/wireless/intel/iwlwifi/iwl-config.h b/drivers/net/wireless/intel/iwlwifi/iwl-config.h
index 26d0faa44695..cdb3f4abd21b 100644
--- a/drivers/net/wireless/intel/iwlwifi/iwl-config.h
+++ b/drivers/net/wireless/intel/iwlwifi/iwl-config.h
@@ -623,7 +623,6 @@ extern const struct iwl_cfg iwl9560_2ac_cfg_soc;
 extern const struct iwl_cfg iwl_qu_hr1;
 extern const struct iwl_cfg iwl_qu_hr;
 extern const struct iwl_cfg iwl_ax200_cfg_cc;
-extern const struct iwl_cfg iwl_ax201_cfg_qu_hr;
 extern const struct iwl_cfg iwlax210_2ax_cfg_so_jf_b0;
 extern const struct iwl_cfg iwlax211_2ax_cfg_so_gf_a0;
 extern const struct iwl_cfg iwlax211_2ax_cfg_so_gf_a0_long;
diff --git a/drivers/net/wireless/intel/iwlwifi/pcie/drv.c b/drivers/net/wireless/intel/iwlwifi/pcie/drv.c
index 0a068ca6fee8..db9b582795ba 100644
--- a/drivers/net/wireless/intel/iwlwifi/pcie/drv.c
+++ b/drivers/net/wireless/intel/iwlwifi/pcie/drv.c
@@ -647,137 +647,137 @@ VISIBLE_IF_IWLWIFI_KUNIT const struct iwl_dev_info iwl_dev_info_table[] = {
 		     DEVICE(0x2723), SUBDEV(0x1654), BW_NO_LIMIT),
 
 	/* Qu with Hr */
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x43F0), SUBDEV(0x0070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x43F0), SUBDEV(0x0074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x43F0), SUBDEV(0x0078), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x43F0), SUBDEV(0x007C), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650s_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650s_name,
 		     DEVICE(0x43F0), SUBDEV(0x1651), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650i_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650i_name,
 		     DEVICE(0x43F0), SUBDEV(0x1652), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x43F0), SUBDEV(0x2074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x43F0), SUBDEV(0x4070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x0070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x0074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x0078), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x007C), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x0A10), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650s_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650s_name,
 		     DEVICE(0xA0F0), SUBDEV(0x1651), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650i_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650i_name,
 		     DEVICE(0xA0F0), SUBDEV(0x1652), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x2074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x4070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0xA0F0), SUBDEV(0x6074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x0070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x0074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x6074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x0078), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x007C), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x0310), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650s_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650s_name,
 		     DEVICE(0x02F0), SUBDEV(0x1651), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650i_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650i_name,
 		     DEVICE(0x02F0), SUBDEV(0x1652), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x2074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x02F0), SUBDEV(0x4070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x06F0), SUBDEV(0x0070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x06F0), SUBDEV(0x0074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x06F0), SUBDEV(0x0078), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x06F0), SUBDEV(0x007C), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x06F0), SUBDEV(0x0310), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650s_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650s_name,
 		     DEVICE(0x06F0), SUBDEV(0x1651), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650i_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650i_name,
 		     DEVICE(0x06F0), SUBDEV(0x1652), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x06F0), SUBDEV(0x2074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x06F0), SUBDEV(0x4070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x34F0), SUBDEV(0x0070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x34F0), SUBDEV(0x0074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x34F0), SUBDEV(0x0078), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x34F0), SUBDEV(0x007C), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x34F0), SUBDEV(0x0310), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650s_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650s_name,
 		     DEVICE(0x34F0), SUBDEV(0x1651), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650i_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650i_name,
 		     DEVICE(0x34F0), SUBDEV(0x1652), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x34F0), SUBDEV(0x2074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x34F0), SUBDEV(0x4070), BW_NO_LIMIT),
 
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x3DF0), SUBDEV(0x0070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x3DF0), SUBDEV(0x0074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x3DF0), SUBDEV(0x0078), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x3DF0), SUBDEV(0x007C), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x3DF0), SUBDEV(0x0310), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650s_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650s_name,
 		     DEVICE(0x3DF0), SUBDEV(0x1651), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650i_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650i_name,
 		     DEVICE(0x3DF0), SUBDEV(0x1652), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x3DF0), SUBDEV(0x2074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x3DF0), SUBDEV(0x4070), BW_NO_LIMIT),
 
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x0070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x0074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x0078), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x007C), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x0310), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650s_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650s_name,
 		     DEVICE(0x4DF0), SUBDEV(0x1651), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, iwl_ax201_killer_1650i_name,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_killer_1650i_name,
 		     DEVICE(0x4DF0), SUBDEV(0x1652), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x2074), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x4070), BW_NO_LIMIT),
-	IWL_DEV_INFO(iwl_ax201_cfg_qu_hr, NULL,
+	IWL_DEV_INFO(iwl_qu_hr, iwl_ax201_name,
 		     DEVICE(0x4DF0), SUBDEV(0x6074), BW_NO_LIMIT),
 
 	/* So with HR */